<template>
  <BaseCard
    :title="title"
    :main-user="mainUser"
    :external-link="externalLink"
    :date="date"
    :skeleton="skeleton"
  >
    <template #userdate>
      <div class="mt-1">
        <b-row v-if="skeleton" align-h="center" class="g-0">
          <div class="skeleton-authordate mx-auto">
            <ContentLoader width="200" height="15">
              <rect x="0" y="0" rx="5" ry="5" width="200" height="15" />
            </ContentLoader>
          </div>
        </b-row>
        <b-row v-else align-h="center" class="g-0">
          <b-col sm="auto">
            <span
              v-b-tooltip.hover.right="{ variant: 'dark' }"
              :title="mainUser.fullName"
            >
              {{ mainUser.firstName }}
            </span>
          </b-col>
          <b-col sm="auto" class="d-none d-sm-block">,</b-col>
          <b-col sm="auto" class="ml-1">
            <span
              v-b-tooltip.hover.bottom="{ variant: 'dark' }"
              :title="date | timeago"
            >
              {{ date | formatDate('PP') | stripComma }}
            </span>
          </b-col>
        </b-row>
      </div>
    </template>
    <template v-for="(index, name) in $slots" #[name]>
      <slot :name="name" />
    </template>
  </BaseCard>
</template>

<script>
export default {
  props: {
    title: {
      type: String,
      default: '',
    },
    externalLink: {
      type: String,
      default: '',
    },
    mainUser: {
      type: Object,
      default() {
        return {
          fullName: '',
          firstName: '',
        };
      },
    },
    date: {
      type: String,
      default: '',
    },
    skeleton: {
      type: Boolean,
      defaul: '',
    },
  },
};
</script>

<style>
.skeleton-authordate {
  max-width: 80%;
}
</style>
